Index: /pjproject/trunk/aconfigure.ac
===================================================================
--- /pjproject/trunk/aconfigure.ac	(revision 3056)
+++ /pjproject/trunk/aconfigure.ac	(revision 3057)
@@ -147,6 +147,12 @@
 AC_CHECK_HEADER(netinet/in.h,[AC_DEFINE(PJ_HAS_NETINET_IN_H,1)])
 AC_CHECK_HEADER(netinet/ip.h,[AC_DEFINE(PJ_HAS_NETINET_IP_H,1)],[],
-		 [#if PJ_HAS_NETINET_IN_SYSTM_H
+		 [#if PJ_HAS_SYS_TYPES_H
+          	  #	include <sys/types.h>
+          	  #endif
+		  #if PJ_HAS_NETINET_IN_SYSTM_H
           	  #	include <netinet/in_systm.h>
+          	  #endif
+		  #if PJ_HAS_NETINET_IN_H
+          	  #	include <netinet/in.h>
           	  #endif
           	 ])
@@ -181,9 +187,12 @@
 AC_CHECK_HEADER(uuid/uuid.h,[ac_has_uuid_h=1])
 AC_CHECK_HEADER(net/if.h,[AC_DEFINE(PJ_HAS_NET_IF_H,1)],[],
-		 [#if PJ_HAS_SYS_SOCKET_H
+		 [#if PJ_HAS_SYS_TYPES_H
+          	  #	include <sys/types.h>
+          	  #endif
+		  #if PJ_HAS_SYS_SOCKET_H
+
           	  #	include <sys/socket.h>
           	  #endif
           	 ])
-
 AC_MSG_RESULT([Setting PJ_OS_NAME to $target])
 AC_DEFINE_UNQUOTED(PJ_OS_NAME,["$target"])
@@ -257,5 +266,6 @@
 dnl # Determine if socklen_t is available
 AC_MSG_CHECKING([if socklen_t is available])
-AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <sys/socket.h>]],
+AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <sys/types.h>
+                                     #include <sys/socket.h>]],
 		    		   [socklen_t xxx = 0;])],
 		  [AC_DEFINE(PJ_HAS_SOCKLEN_T,1)
@@ -755,6 +765,6 @@
 		AC_SUBST(libcrypto_present)
 		AC_CHECK_HEADER(openssl/ssl.h,[openssl_h_present=1])
+		AC_CHECK_LIB(crypto,ERR_load_BIO_strings,[libcrypto_present=1 && LIBS="$LIBS -lcrypto"])
 		AC_CHECK_LIB(ssl,SSL_library_init,[libssl_present=1 && LIBS="$LIBS -lssl"])
-		AC_CHECK_LIB(crypto,ERR_load_BIO_strings,[libcrypto_present=1 && LIBS="$LIBS -lcrypto"])
 		if test "x$openssl_h_present" = "x1" -a "x$libssl_present" = "x1" -a "x$libcrypto_present" = "x1"; then
 	        	AC_MSG_RESULT([OpenSSL library found, SSL support enabled])
Index: /pjproject/trunk/pjlib-util/src/pjlib-util-test/resolver_test.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util-test/resolver_test.c	(revision 3056)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util-test/resolver_test.c	(revision 3057)
@@ -814,6 +814,6 @@
      * in STATE_ACTIVE state
      */
-    pj_assert(g_server[0].pkt_count == 1);
-    pj_assert(g_server[1].pkt_count == 0);
+    pj_assert((g_server[0].pkt_count == 1 && g_server[1].pkt_count == 0) ||
+	      (g_server[1].pkt_count == 1 && g_server[0].pkt_count == 0));
 
     /* Wait to allow probing period to complete */
Index: /pjproject/trunk/pjlib/src/pj/guid_simple.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/guid_simple.c	(revision 3056)
+++ /pjproject/trunk/pjlib/src/pj/guid_simple.c	(revision 3057)
@@ -68,8 +68,10 @@
 
     for (p=str->ptr, end=p+PJ_GUID_STRING_LENGTH; p<end; ) {
-	/* Assumes rand() only has 16bit randomness */
-	unsigned short val = pj_rand();
-	*p++ = guid_chars[(val >> 8)   & 63];
-	*p++ = guid_chars[(val & 0xFF) & 63];
+	pj_uint32_t rand_val = pj_rand();
+	pj_uint32_t rand_idx = RAND_MAX;
+
+	for ( ; rand_idx>0 && p<end; rand_idx>>=8, rand_val>>=8, p++) {
+	    *p = guid_chars[(rand_val & 0xFF) & 63];
+	}
     }
 
Index: /pjproject/trunk/pjlib/src/pj/os_core_unix.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/os_core_unix.c	(revision 3056)
+++ /pjproject/trunk/pjlib/src/pj/os_core_unix.c	(revision 3057)
@@ -309,5 +309,12 @@
 	return -1;
 
+#if defined _POSIX_PRIORITY_SCHEDULING
     return sched_get_priority_min(policy);
+#elif defined __OpenBSD__
+    return 0;
+#else
+    pj_assert("pj_thread_get_prio_min() not supported!");
+    return 0;
+#endif
 }
 
@@ -326,5 +333,12 @@
 	return -1;
 
+#if defined _POSIX_PRIORITY_SCHEDULING
     return sched_get_priority_max(policy);
+#elif defined __OpenBSD__
+    return 31;
+#else
+    pj_assert("pj_thread_get_prio_max() not supported!");
+    return 0;
+#endif
 }
 
Index: /pjproject/trunk/pjlib/src/pjlib-test/activesock.c
===================================================================
--- /pjproject/trunk/pjlib/src/pjlib-test/activesock.c	(revision 3056)
+++ /pjproject/trunk/pjlib/src/pjlib-test/activesock.c	(revision 3057)
@@ -338,5 +338,5 @@
 static int tcp_perf_test(void)
 {
-    enum { COUNT=100000 };
+    enum { COUNT=10000 };
     pj_pool_t *pool = NULL;
     pj_ioqueue_t *ioqueue = NULL;
@@ -437,4 +437,13 @@
 		}
 	}
+
+#ifndef PJ_SYMBIAN
+	for (;;) {
+	    pj_time_val timeout = {0, 10};
+	    if (pj_ioqueue_poll(ioqueue, &timeout) < 1)
+		break;
+	}
+#endif
+
     }
 
Index: /pjproject/trunk/pjlib/src/pjlib-test/ioq_unreg.c
===================================================================
--- /pjproject/trunk/pjlib/src/pjlib-test/ioq_unreg.c	(revision 3056)
+++ /pjproject/trunk/pjlib/src/pjlib-test/ioq_unreg.c	(revision 3057)
@@ -94,4 +94,5 @@
 	    sock_data.unregistered = 1;
 	    pj_ioqueue_unregister(key);
+	    pj_mutex_unlock(sock_data.mutex);
 	    return;
 	}
